﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        CustomItemTemplate _CustomItemTemplate = new CustomItemTemplate();
        Infragistics.Web.UI.ItemTemplate _ItemTemplate = new Infragistics.Web.UI.ItemTemplate();
        _ItemTemplate.Template = _CustomItemTemplate;
        _ItemTemplate.TemplateID = "CustomItemTemplate";
        this.WebHierarchicalDataGrid1.Templates.Add(_ItemTemplate);

    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (IsPostBack)
        {
            if (WebHierarchicalDataGrid1.Bands.Count > 1)
            {
                TemplateDataField templateColumn1 = (TemplateDataField)WebHierarchicalDataGrid1.Bands[0].Columns["Button"];
                templateColumn1.ItemTemplate = new CustomItemTemplate();
            }
        }
    }

    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;

        ContainerGrid child = new ContainerGrid();
        child.Enabled = true;       
        child.Level = 1;
        child.AutoGenerateColumns = false;

        TemplateDataField tf = new TemplateDataField();
        tf.Key = "Button";
        tf.ItemTemplate = new CustomItemTemplate();
        tf.Header.Text = "Button";
        child.Columns.Add(tf);

        e.Row.RowIslands.Add(child);

      //  Paging paging = child.Behaviors.CreateBehavior<Paging>();
     //   paging.Enabled = true;
     //   paging.PageSize = 4;

       // Selection selection = child.Behaviors.CreateBehavior<Selection>();
        //selection.Enabled = true;
       // selection.CellClickAction = CellClickAction.Row;
       // selection.RowSelectType = SelectType.Single;
        RowSelectors selectorBehavior = child.Behaviors.CreateBehavior<RowSelectors>();
        // selectorBehavior.Enabled = true;
        selectorBehavior.RowNumbering = true;


        child.DataSourceID = SqlDataSource2.ID;
       

        child.DataBind();


    }


    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }

}

public class CustomItemTemplate : ITemplate
{
    #region ITemplate Members

    public void InstantiateIn(Control container)
    {      

        Button Btn = new Button();
        Btn.Text = "MyTmpBtn";
        container.Controls.Add(Btn);
    }

    #endregion
}
